using System;
using System.Collections.Generic;
using Library;
using LitJson;
using System.Linq;
using System.Data;
using System.Threading;
using MySystem.PxcModels2;

namespace MySystem
{
    public class TestService2
    {
        public readonly static TestService2 Instance = new TestService2();
        private TestService2()
        { }






        // 统计交易额V2
        public void Start()
        {
            Thread th = new Thread(StartDo);
            th.IsBackground = true;
            th.Start();
        }
        public void StartDo()
        {
            while(true)
            {
                string content = RedisDbconn.Instance.RPop<string>("ResetUserTrade2Queue");
                if(!string.IsNullOrEmpty(content))
                {
                    StatTradeAmount(content);
                }
                else
                {
                    Thread.Sleep(60000);
                }
            }
        }
        public void StatTradeAmount(string date)
        {
            function.WriteLog(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff"), "重置创客交易额2日志");
            WebCMSEntities db = new WebCMSEntities();
            KxsMainModels.WebCMSEntities maindb = new KxsMainModels.WebCMSEntities();
            using (var tran = db.Database.BeginTransaction())
            {
                try
                {
                    DataTable idsDt = CustomerSqlConn.dtable("select Id from ConsumerOrders where CreateDate>='" + date + " 00:00:00' and CreateDate<='" + date + " 23:59:59' and Status>0 and version=1", AppConfig.Base.SqlConn2);
                    if(idsDt.Rows.Count > 0)
                    {
                        string ids = "";
                        foreach (DataRow idsDr in idsDt.Rows)
                        {
                            ids += idsDr["Id"].ToString() + ",";
                        }
                        DataTable selfDt = CustomerSqlConn.dtable("select UserId,MerchantId,SnNo,PayMode,IsAct,DATE_FORMAT(CreateDate,'%Y%m%d'),sum(PayMoney),count(Id),sum(MaxDivi),sum(MerchantActualAmount) from ConsumerOrders where Id in (" + ids.TrimEnd(',') + ") group by UserId,MerchantId,SnNo,PayMode,IsAct,DATE_FORMAT(CreateDate,'%Y%m%d')", AppConfig.Base.SqlConn2);
                        if (selfDt.Rows.Count > 0)
                        {
                            CustomerSqlConn.dtable("delete from UserAmountSummary where TradeDate='" + date.Replace("-", "") + "'", AppConfig.Base.SqlConn2);
                            function.WriteLog("统计人数:" + selfDt.Rows.Count + "\n\n", "重置创客交易额2日志");
                            foreach (DataRow selfDr in selfDt.Rows)
                            {
                                int UserId = int.Parse(selfDr["UserId"].ToString());
                                KxsMainModels.Users user = maindb.Users.FirstOrDefault(m => m.Id == UserId) ?? new KxsMainModels.Users();
                                string ParentNav = user.ParentNav;
                                int MerchantId = int.Parse(selfDr["MerchantId"].ToString());
                                int PayMode = int.Parse(selfDr["PayMode"].ToString());
                                int IsAct = int.Parse(selfDr["IsAct"].ToString());
                                string SnNo = selfDr["SnNo"].ToString();
                                string TradeDate = selfDr[5].ToString();
                                decimal TradeAmount = decimal.Parse(selfDr[6].ToString());
                                int TradeCount = int.Parse(selfDr[7].ToString());
                                decimal MaxDivi = decimal.Parse(selfDr[8].ToString());
                                decimal ActualAmount = decimal.Parse(selfDr[9].ToString());
                                string TradeMonth = TradeDate.Substring(0, 6);

                                //创客交易额
                                UserAmountSummary selfStat = db.UserAmountSummary.FirstOrDefault(m => m.UserId == UserId && m.IsAct == IsAct && m.TradeMonth == TradeMonth && m.TradeDate == TradeDate && m.PayMode == PayMode && m.SeoTitle == "self");
                                if (selfStat == null)
                                {
                                    selfStat = db.UserAmountSummary.Add(new UserAmountSummary()
                                    {
                                        UserId = UserId,
                                        TradeMonth = TradeMonth,
                                        TradeDate = TradeDate,
                                        PayMode = PayMode,
                                        IsAct = IsAct,
                                        SeoTitle = "self",
                                    }).Entity;
                                    db.SaveChanges();
                                }
                                selfStat.TotalAmount += TradeAmount;
                                selfStat.TradeCount += TradeCount;
                                ParentNav += "," + UserId + ",";
                                if (!string.IsNullOrEmpty(ParentNav))
                                {
                                    string[] ParentNavList = ParentNav.Trim(',').Replace(",,", ",").Split(',');
                                    foreach (string NavUserIdString in ParentNavList)
                                    {
                                        int NavUserId = int.Parse(NavUserIdString);
                                        UserAmountSummary teamStat = db.UserAmountSummary.FirstOrDefault(m => m.UserId == NavUserId && m.IsAct == IsAct && m.TradeMonth == TradeMonth && m.TradeDate == TradeDate && m.PayMode == PayMode && m.SeoTitle == "team");
                                        if (teamStat == null)
                                        {
                                            teamStat = db.UserAmountSummary.Add(new UserAmountSummary()
                                            {
                                                UserId = NavUserId,
                                                TradeMonth = TradeMonth,
                                                TradeDate = TradeDate,
                                                PayMode = PayMode,
                                                IsAct = IsAct,
                                                SeoTitle = "team",
                                            }).Entity;
                                            db.SaveChanges();
                                        }
                                        teamStat.TotalAmount += TradeAmount;
                                        teamStat.TradeCount += TradeCount;
                                    }
                                }
                                db.SaveChanges();
                            }
                        }
                    }
                    tran.Commit();
                }
                catch (Exception ex)
                {
                    tran.Rollback();
                    function.WriteLog(DateTime.Now.ToString() + "\n" + ex.ToString(), "重置创客交易额2异常");
                }
            }
            db.Dispose();
            maindb.Dispose();
            function.WriteLog(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff") + "\n\n", "重置创客交易额2日志");
        }
    }
}